@echo off

rem ****************************************************************************
rem ** 
rem ** SYNTAX: BUILD_VS r|c|d win32|x64 folder-name project-name
rem ** 
rem ** BUILD_VS uses Visual Studio 2005, or Visual C++ 2005 Express Edition
rem ** to compile the specified project. Note that the PSDK compiler is used
rem ** for x64 targets if only the Visual C++ 2005 Express Edition is available.
rem ** 
rem ** r|c|d: one of the configurations `Release', `Checked Release' or `Debug'
rem ** win32|x64: one of the supported target platforms
rem ** 
rem ****************************************************************************

if "%1" equ "" goto :eof
if "%1" equ "build2" goto :use_psdk_compiler2

set TARGETPATH=

set VS2005=
set PSDK=
if "%ProgramFiles(x86)%" equ "" set ProgramFiles(x86)=%ProgramFiles%
call "%~dp0..\setenv.bat"
if "%VS2005%" equ "" goto :no_vs2005

set VS2005_EXPRESS=
set VS2005_DEVENV=%VS2005%\Common7\IDE\devenv.exe
if exist "%VS2005_DEVENV%" goto devenv_exists
set VS2005_EXPRESS=%VS2005%\Common7\IDE\VCExpress.exe
set VS2005_DEVENV=%VS2005_EXPRESS%
if exist "%VS2005_DEVENV%" goto :devenv_exists
set VS2005_EXPRESS=
set VS2005_DEVENV=
goto :no_vs2005
:devenv_exists

set VS2005_CFG=
if /i "%1" equ "r" set VS2005_CFG=Release
if /i "%1" equ "c" set VS2005_CFG=Checked Release
if /i "%1" equ "d" set VS2005_CFG=Debug
if "%VS2005_CFG%" equ "" goto :no_config
set VS2005_TARGET=
if /i "%2" equ "win32" set VS2005_TARGET=Win32
if /i "%2" equ "x64" set VS2005_TARGET=x64
if "%VS2005_TARGET%" equ "" goto :no_target
set VS2005_NAME=%~3
if "%VS2005_NAME%" equ "" goto :no_name
set VS2005_PRJ=%~4
if "%VS2005_PRJ%" equ "" set VS2005_PRJ=%VS2005_NAME%

if "%VS2005_EXPRESS%" equ "" goto :use_ide_compiler
if "%VS2005_TARGET%" equ "x64" goto :use_psdk_compiler

:use_ide_compiler
set TARGETPATH=%~dp0..\src\%VS2005_NAME%\obj\%VS2005_PRJ%\%VS2005_CFG%\%VS2005_TARGET%
"%VS2005_DEVENV%" "%~dp0..\src\%VS2005_NAME%\%VS2005_PRJ%.sln" /build "%VS2005_CFG%|%VS2005_TARGET%" /project "%VS2005_PRJ%"
goto :eof

:use_psdk_compiler
set TARGETPATH=%~dp0..\src\%VS2005_NAME%\obj\%VS2005_PRJ%\x64-PSDK %VS2005_CFG%\Win32
if "%PSDK%" equ "" goto :no_psdk
if not exist "%PSDK%\bin\setenv.cmd" goto :no_psdk
set ARG0=%~f0
start "Compiling %VS2005_NAME%..." /w cmd.exe /C "%~f0" build2
goto :eof

:use_psdk_compiler2
set VS2005_SOLUTION=%~dp0..\src\%VS2005_NAME%\%VS2005_PRJ%.sln
cd /d "%PSDK%\bin"
set CFG_SWITCH=/Release
if "%VS2005_CFG%" equ "Debug" set CFG_SWITCH=/Debug
call setenv %CFG_SWITCH% /x64 /xp
"%VS2005_DEVENV%" "%VS2005_SOLUTION%" /build "x64-PSDK %VS2005_CFG%|Win32" /project "%VS2005_PRJ%" /useenv
goto :eof

:no_vs2005
cls
echo.Cannot find Visual Studio 2005 or Visual Studio 2005 Express Edition
echo.Please edit the file `setenv.bat'
echo.
pause
notepad "%~dp0..\setenv.bat"
if "%__MAPDRIVE%" neq "" call "%dp0map" /D
exit 1

:no_psdk
cls
echo.Cannot find Windows SDK for Windows Vista v6.0
echo.Please edit the file `setenv.bat'
echo.
pause
notepad "%~dp0..\setenv.bat"
if "%__MAPDRIVE%" neq "" call "%dp0map" /D
exit 1

:no_config
:no_target
:no_name
goto :eof
